/// The output property cannot be one of the input properties for REFPROP.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct RefpropOutputPropertyIsInput {
    #[builder(into)]
    #[serde(rename = "outputProperty")]
    output_property: String,
    #[builder(into)]
    #[serde(rename = "firstProperty")]
    first_property: String,
    #[builder(into)]
    #[serde(rename = "secondProperty")]
    second_property: String,
}
impl RefpropOutputPropertyIsInput {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        output_property: impl Into<String>,
        first_property: impl Into<String>,
        second_property: impl Into<String>,
    ) -> Self {
        Self::builder()
            .output_property(output_property)
            .first_property(first_property)
            .second_property(second_property)
            .build()
    }
    #[inline]
    pub fn output_property(&self) -> &str {
        &*self.output_property
    }
    #[inline]
    pub fn first_property(&self) -> &str {
        &*self.first_property
    }
    #[inline]
    pub fn second_property(&self) -> &str {
        &*self.second_property
    }
}
impl conjure_error::ErrorType for RefpropOutputPropertyIsInput {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::InvalidArgument
    }
    #[inline]
    fn name() -> &'static str {
        "Compute:RefpropOutputPropertyIsInput"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["firstProperty", "outputProperty", "secondProperty"]
    }
}
